{{- $menu := merge site.Data.menu (.Params.menu | default dict) -}}

{{- if not $menu.hide -}}

  {{/*  VARIABLES  */}}
  {{- $sectioned    := eq .Type "page" | and (ne .Kind "404") -}}
  {{- $sticky       := ne .Params.sections nil -}}
  {{- $logo         := $menu.logo -}}
  {{ if (and (not $sectioned) $menu.articles_sticky) | or (and $sectioned $menu.logo) -}}
    {{- $sticky      = true -}}
  {{- else if .Params.header_article | or $menu.hide_sticky | or (not $menu.screen_sticky) -}}
    {{- $sticky      = false -}}
  {{- end -}}
  {{ if and (not $logo) (not $sectioned) $menu.articles_sticky -}}
    {{- $logo        = site.Data.articles.content.logo -}}
  {{- end -}}
  {{- $sections     := slice -}}
  {{- with partial "functions/sections" . -}}
    {{- $sections    = after 1 . -}}
  {{- end -}}
  {{- $show_modals  := $menu.show_modals -}}
  {{- with $menu.hide_modals -}}
    {{- $show_modals = not . -}}
  {{- end -}}
  {{- $normal := slice -}}
  {{- $more   := slice -}}


  {{/*  HOME LINK  */}}
  {{ if not $logo }}
    {{ if not .IsHome | and (not $menu.hide_anchors) }}
      {{ with site.Home }}
        {{ $normal = $normal | append (dict
          "link"     .RelPermalink
          "icon"     "house"
          "emoji"    "🏠"
          "label"    .Title
          "anchor"   (partial "functions/anchor-page" .)
        ) }}
      {{ end }}
    {{ end }}
  {{ end }}


  {{/*  SECTIONS TO ITEMS  */}}
  {{ if eq page.Type "page" | and (not $menu.hide_anchors) }}

    {{ with where $sections "button" "!=" "hide" }}
      {{ range . }}
        {{ if .menu | or .anchor | or .title | or (.icon | and .id) }}

          {{ $item := partial "sections/common/menu/item-by-section" . }}

          {{/*  MODALS TO SUBITEMS  */}}
          {{ if $show_modals }}
            {{ $items := slice }}
            {{ with .modals }}
              {{ range . }}
                {{ $child := partial "sections/common/menu/item-by-section" . }}
                {{ $items  = $items | append $child }}
              {{ end }}
            {{ end }}
            {{ $item = (merge $item (dict "items" $items)) }}
          {{ end }}

          {{ $normal = $normal | append $item }}

        {{ end }}
      {{ end }}
    {{ end }}

  {{ end }}


  {{/*  CUSTOM NORMAL ITEMS  */}}
  {{ $items_custom_normal := partial "sections/common/menu/items-custom" (dict "more" false) }}
  {{ range $items_custom_normal }}{{ $normal = $normal | append . }}{{ end }}

  {{/*  ANOTHER ITEMS  */}}
  {{ $items_custom        := partial "sections/common/menu/items-custom" (dict "more" true) }}
  {{ $items_auto          := partial "sections/common/menu/items-auto"   . }}
  {{ $langs_normal_sticky := partial "sections/common/menu/langs"        (dict "more" false) }}
  {{ $langs_more          := partial "sections/common/menu/langs"        (dict "more" true) }}
  {{ $langs_normal        := partial "sections/common/menu/langs"        (dict "no_sticky" true) }}
  {{ $item_search         := partial "sections/common/menu/search"       . }}

  {{ if $sticky }}

    {{/*  MORE ITEMS  */}}
    {{ range $items_custom }}{{ $more = $more | append . }}{{ end }}
    {{ range $items_auto   }}{{ $more = $more | append . }}{{ end }}
    {{ $more = $more | append $item_search }}
    {{ range $langs_more   }}{{ $more = $more | append . }}{{ end }}

    {{/*  ADD MORE TO NORMAL ITEMS  */}}
    {{ with $more }}
      {{ $more = dict
        "icon"  "plus"
        "label" (i18n "more")
        "items" .
        "more"  true
      }}
      {{ $normal = $normal | append $more }}
    {{ end }}

    {{ range $langs_normal_sticky }}{{ $normal = $normal | append . }}{{ end }}

  {{ else }}

    {{/*  NORMAL NO STICKY ITEMS  */}}
    {{ range $items_custom }}{{ $normal = $normal | append . }}{{ end }}
    {{ range $items_auto   }}{{ $normal = $normal | append . }}{{ end }}
    {{ $normal = $normal | append $item_search }}
    {{ range $langs_normal }}{{ $normal = $normal | append . }}{{ end }}

  {{ end }}


  {{/*  PRINT HTML  */}}

  {{- if $normal -}}

    {{/*  MENU TOGGLE  */}}
    <button class="menu__toggle button--icon {{ if $sticky }}menu__toggle--sticky{{ end }}">
      {{- "" }}<b class="menu__toggle-bar"></b>
      {{- "" }}<b class="menu__toggle-bar"></b>
      {{- "" }}<b class="menu__toggle-bar"></b>
      {{- "" }}<i>{{ i18n "scroll-up" }}</i>
      {{- "" -}}
    </button>

    {{/*  BACKOVER  */}}
    <div class="menu__backover"></div>

    {{/*  CLASS  */}}
    {{- $menu_bg          := print "bg bg-" ($menu.color | default "white") -}}
    {{- $menu_sticky      := cond $sticky "menu--sticky" "" -}}
    {{- $menu_class       := delimit (slice
      "menu"
      $menu_bg
      $menu_sticky
      | uniq) " "
    -}}

    {{/*  NAV  */}}
    <nav class="{{ $menu_class }}">
      <div {{ if $sticky }}class="container container--{{ $menu.size_sticky | default `lg` }}"{{ end }}>

        {{/*  HEADER  */}}
        <p class="menu__title h1 {{- with $logo }} menu__title--sublogo{{ end }}">{{ i18n "menu" }}</p>

        <ul class="menu__items">

          {{/*  LOGO  */}}
          {{ with $logo }}
            <li class="menu__item menu__item--logo">
              <a class="menu__link menu__link--logo" href="{{ if page.IsHome }}#{{ else }}/{{ end }}">
                {{ partial "components/image" (dict
                  "svg_src"   true
                  "class"     "menu__logo-image"
                  "src"       .
                  "alt"       (partial "functions/anchor-page" site.Home)
                  "container" "sm"
                  "span"      6
                ) }}
                <i class="hide">{{ site.Home.Params.title_seo | default site.Home.Params.title }}</i>
              </a>
            </li>
          {{ end }}

          {{/*  ITEMS  */}}
          {{ range $normal }}
            {{ partial "sections/common/menu/item" . }}
          {{ end }}

        </ul>
      </div>
    </nav>

  {{ end }}

{{ end }}
